// Precaches
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "spell_pumpkin_mirv_bits_red"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "spell_pumpkin_mirv_bits_blue"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "rd_robot_explosion"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "unusual_festive_lights_glow1"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "unusual_festive_lights_glow3"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "healthgained_red"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "healthgained_blu"}) // Blu lmao
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "arm_detonate_sparks"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "rps_win_flash_red"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "rps_win_flash_blue"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "highfive_red_old"})
PrecacheEntityFromTable({classname = "info_particle_system", effect_name = "highfive_blue_old"})
PrecacheScriptSound("items/gunpickup2.wav")
PrecacheScriptSound("weapons/airstrike_small_explosion_03.wav")
PrecacheScriptSound("weapons/sapper_plant.wav")
PrecacheScriptSound("weapons/sapper_removed.wav")
PrecacheModel("models/buildables/sentry1.mdl")
PrecacheModel("models/player/demo.mdl")
PrecacheModel("models/pickups/pickup_powerup_strength.mdl")
PrecacheModel("models/pickups/pickup_powerup_defense.mdl")
PrecacheModel("models/pickups/pickup_powerup_regen.mdl")
PrecacheModel("models/pickups/pickup_powerup_haste.mdl")
PrecacheModel("models/pickups/pickup_powerup_vampire.mdl")
PrecacheModel("models/pickups/pickup_powerup_reflect.mdl")
PrecacheModel("models/pickups/pickup_powerup_precision.mdl")
PrecacheModel("models/pickups/pickup_powerup_agility.mdl")
PrecacheModel("models/pickups/pickup_powerup_knockout.mdl")
PrecacheModel("models/pickups/pickup_powerup_king.mdl")
PrecacheModel("models/pickups/pickup_powerup_plague.mdl")
PrecacheModel("models/pickups/pickup_powerup_supernova.mdl")
PrecacheModel("models/bots/bot_worker/bot_worker_powercore.mdl")

// Play the robots under attack notification only once, don't ask how I found out about the cvar
Convars.SetValue("tf_rd_robot_attack_notification_cooldown", 99999)

// Robot destruction logic
::logicRD <- ::first("tf_logic_robot_destruction", "FindByClassname") || SpawnEntityFromTable("tf_logic_robot_destruction", {
	targetname = "rd_logic"
	max_points = 2000
	finale_length = 5
	score_interval = 5
})

// Spawn group
::robotSpawnGroup <- SpawnEntityFromTable("tf_robot_destruction_spawn_group", {
	targetname = "robot_spawn_group"
	group_number = 0
})
::createTimer(0, @() NetProps.SetPropInt(::robotSpawnGroup, "m_nState", 4))

// Team control point master
::teamControlPointMaster <- ::first("team_control_point_master","FindByClassname") || SpawnEntityFromTable("team_control_point_master", {
    targetname = "team_control_point_master"
    caplayout = "0 1 2 3 4 5 6 7"
    cpm_restrict_team_cap_win = 1
    switch_teams = 1
    custom_position_y = 0.825
})

// CP Hud
NetProps.SetPropInt(::first("tf_gamerules","FindByClassname"), "m_nHudType", 2)

// Where the robots are telported on death
::limbo <- ::logicRD

// Spawn a dead robot prop
::spawnDeadRobot <- function(origin, angles, teamNum) {
	local prop = SpawnEntityFromTable("prop_physics_override", {
		model = "models/bots/bot_worker/bot_worker2.mdl",
		massScale = 0.02,
		origin = origin.ToKVString(),
		angles = angles.ToKVString(),
		skin = teamNum - 2,
		rendercolor = "75 75 75",
		"OnUser1#1": "!self,AddOutput,renderfx 5,6,1",
		"OnUser1#2": "!self,Kill,,10,1"
	})
	prop.SetSolidFlags(2)
	::fire(prop, "FireUser1")
}

// Spawn a points giving core
::spawnCore <- function(props) {
    if (!("origin" in props)) return ::printError("Failed to spawn core! Missing \"origin\" (Vector) property.")
    if (!("teamNum" in props)) return ::printError("Failed to spawn core! Missing \"teamNum\" (2|3) property.")
    if (!(props.teamNum == 2 || props.teamNum == 3)) return ::printError("Failed to spawn core! \"teamNum\" property must be either 2 or 3.")
	if (!("basevelocity" in props)) props.basevelocity <- Vector(RandomFloat(-100,100),RandomFloat(-100,100),5) // NoT A cIrcLe
	if (!("value" in props)) props.value <- 1

	// Create entities
	local core = SpawnEntityFromTable("item_powerup_rune", {
		powerup_model = "models/bots/bot_worker/bot_worker_powercore.mdl",
		origin = props.origin.ToKVString(),
		basevelocity = props.basevelocity.ToKVString(),
		skin = props.teamNum - 2,
		TeamNum = 4,
		rendermode = 5,
		"OnCacheInteraction": "!self,RunScriptCode,handleTouch(),0,-1"
		"OnUser1": "!self,RunScriptCode,triggerFadePhase(),5,1"
		"OnUser2": "!self,RunScriptCode,triggerFadePhase(),0,-1"
	})
	local particle = SpawnEntityFromTable("info_particle_system", {
		effect_name = [
			"unusual_festive_lights_glow3" // Blue particle
			"unusual_festive_lights_glow1" // Red particle
		][props.teamNum-2],
		start_active = 1
	})

	// Setup core
	::fire(core, "FireUser1")
	NetProps.SetPropEntity(particle, "moveparent", core)
	local coreScope = ::getScope(core)
	coreScope.teamNum <- props.teamNum
	coreScope.value <- props.value
	coreScope.touched <- false
	coreScope.particle <- particle

	// Setup fading animation
	coreScope.fadePhase <- 0
	coreScope.fadePhaseAmt <- 5
	coreScope.fadePhaseDuration <- 1
	coreScope.triggerFadePhase <- function() {
		if (fadePhase == fadePhaseAmt) {
			particle.Kill()
			self.Kill()
		}
		else {
			::fire(self, "AddOutput", "renderamt "+(255-(fadePhase*255/fadePhaseAmt)))
			::fire(self, "FireUser2", "", fadePhaseDuration)
			fadePhase++
		}
	}

	// Handle core touch
	coreScope.handleTouch <- function() {
		if (activator.GetTeam() != teamNum && !touched) {
			touched = true
			DispatchParticleEffect(
                ["spell_pumpkin_mirv_bits_red", "spell_pumpkin_mirv_bits_blue"][teamNum-2],
                self.GetOrigin()+Vector(0,0,16),
                Vector(0,0,0)
            )
			EmitSoundEx({
				sound_name = "items/gunpickup2.wav"
				origin = self.GetOrigin()+Vector(0,0,16)
				sound_level = 70
			})
			local scoreAdder = [::match.score.blue.add, ::match.score.red.add][teamNum-2]
			scoreAdder(value)
			particle.Kill()
			self.Kill()
		}
	}

}

// Match info and helpers
::match <- {
    consts =  {
        red = {
            num = 2
            scoreNetProp = "m_nRedScore"
            targetPointsNetProp = "m_nRedTargetPoints"
            finaleEndTimeNetProp = "m_flRedFinaleEndTime"
        }
        blue = {
            num = 3
            scoreNetProp = "m_nBlueScore"
            targetPointsNetProp = "m_nBlueTargetPoints"
            finaleEndTimeNetProp = "m_flBlueFinaleEndTime"
        }
    }
    isOver = false
    score = {
        red = {
			value = 0
		}
        blue = {
			value = 0
		}
        max = 999
    }
    passiveAdder = {
        red = {
            level = 0
        }
        blue = {
            level = 0
        }
    }
}

// Score setter
::match.score.set <- function[::match](team, amt) {
    if (!isOver) {
        score[team].value = amt
        if (score[team].value > score.max) score[team].value = score.max
        if (score[team].value == score.max) {
            isOver = true
            playFinale(team)
        }
        NetProps.SetPropInt(::logicRD, consts[team].scoreNetProp, score[team].value)
        NetProps.SetPropInt(::logicRD, consts[team].targetPointsNetProp, score[team].value)
    }
}
::match.score.add <- @[::match](team, amt) score.set(team, score[team].value+amt)
::match.score.red.set <- @[::match](amt) score.set("red", amt)
::match.score.red.add <- @[::match](amt) score.add("red", amt)
::match.score.blue.set <- @[::match](amt) score.set("blue", amt)
::match.score.blue.add <- @[::match](amt) score.add("blue", amt)

// Play finale
::match.playFinale <- function[::match](team) {
    local finaleDuration = NetProps.GetPropFloat(::logicRD, "m_flFinaleLength")
    NetProps.SetPropFloat(::logicRD, consts[team].finaleEndTimeNetProp, Time()+finaleDuration)
    ::fire(::teamControlPointMaster, "SetWinner", ""+consts[team].num, finaleDuration)
}

// Update passive adder level
::match.passiveAdder.setLevel <- function[::match](team, level) {
    passiveAdder[team].level = level
    if (passiveAdder[team].level > 0) {
		::fire(passiveAdder[team].timer, "RefireTime", ""+(1.0/passiveAdder[team].level))
		::fire(passiveAdder[team].timer, "Enable")
	}
	else {
		::fire(passiveAdder[team].timer, "Disable")
		::fire(passiveAdder[team].timer, "ResetTimer")
	}
}
::match.passiveAdder.addLevel <- @[::match](team, level) passiveAdder.setLevel(team, passiveAdder[team].level+level)
::match.passiveAdder.red.setLevel <- @[::match](amt) passiveAdder.setLevel("red", amt)
::match.passiveAdder.red.addLevel <- @[::match](amt) passiveAdder.addLevel("red", amt)
::match.passiveAdder.blue.setLevel <- @[::match](amt) passiveAdder.setLevel("blue", amt)
::match.passiveAdder.blue.addLevel <- @[::match](amt) passiveAdder.addLevel("blue", amt)

// Start the match
::setupRD <- function() {

	::robots = []
    ::match.isOver = false
    ::match.score.red.set(0)
    ::match.score.blue.set(0)
    ::match.score.max = NetProps.GetPropInt(::logicRD, "m_nMaxPoints")
	::match.passiveAdder.red.timer <- SpawnEntityFromTable("logic_timer", {StartDisabled = 1, "OnTimer": "!self,RunScriptCode,::match.score.red.add(1),0,-1"})
	::match.passiveAdder.blue.timer <- SpawnEntityFromTable("logic_timer", {StartDisabled = 1, "OnTimer": "!self,RunScriptCode,::match.score.blue.add(1),0,-1"})
    ::match.passiveAdder.red.setLevel(0)
    ::match.passiveAdder.blue.setLevel(0)

	// Setup the robot spawns
	foreach (robotSpawn in ::collect("tf_robot_destruction_robot_spawn", "FindByClassname")) {
		local setupData = {
			target = SpawnEntityFromTable("path_track", {targetname = "robot_target_"+robotSpawn.entindex()})
			initialName = robotSpawn.GetName()
			initialLocation = NetProps.GetPropString(robotSpawn, "m_spawnData.m_pszPathName")
			initialGroup = NetProps.GetPropString(robotSpawn, "m_spawnData.m_pszGroupName")
			initialMaxHealth = NetProps.GetPropInt(robotSpawn, "m_spawnData.m_nRobotHealth")
		}
		NetProps.SetPropEntity(setupData.target, "m_pnext", setupData.target)
		NetProps.SetPropString(robotSpawn, "m_iName", "robot_"+robotSpawn.entindex())
		NetProps.SetPropString(robotSpawn, "m_spawnData.m_pszPathName", setupData.target.GetName())
		NetProps.SetPropString(robotSpawn, "m_spawnData.m_pszGroupName", "robot_spawn_group")
		NetProps.SetPropInt(robotSpawn, "m_spawnData.m_nRobotHealth", 99999)
		::getScope(robotSpawn).setupData <- setupData
	}

	// Handle the robots once they are created for this round
	EntityOutputs.AddOutput(::robotSpawnGroup, "OnRobotsRespawn", "!self", "RunScriptCode", "::setupRobots()", 0, 1)

}

::robotsDelegate <- {
	
	goTo = function(entity) {
		::call(entity, "handleRobotIncoming", this) || doGoTo(entity) // Hook
		return this
	}
	
	doGoTo = function(entity) {
		local oldDestination = destination
		destination = null
		target.SetAbsOrigin(entity ? entity.GetOrigin() : bot.GetOrigin())
		// Needs a slight delay before setting the destination or we risk "handleRobotArrival" firing too early
		::createTimer(0, function[this]() {
			destination = entity
			EntityOutputs.AddOutput(target, "OnPass", "!self", "RunScriptCode", "handleOnPass()", 0, 1)
			if (oldDestination) ::call(oldDestination, "handleRobotIncomingCancellation", this) // Hook
		})
		return this
	}
	
	stop = function() {
		doGoTo(null)
		return this
	}
	
	teleportTo = function(entity) {
		::call(entity, "handleRobotTeleport", this) || doTeleportTo(entity) // Hook
		return this
	}
	
	doTeleportTo = function(entity) {
		bot.SetAbsOrigin(entity.GetOrigin())
		bot.SetAbsAngles(entity.GetAbsAngles())
		return this
	}
	
	locateTo = function(entity) {
		teleportTo(entity)
		goTo(entity)
		return this
	}

	handleOnPass = function() {
		target.SetAbsOrigin(bot.GetOrigin()+Vector(0,0,9999)) // Put the target away, this stops the "InPass" spam in console
		if (!destination) return
		local oldDestination = destination
		destination = null
		::call(oldDestination, "handleRobotArrival", this) // Hook
	}
	
	handleDamage = function(info) {
		if (info.damage == 0 || info.attacker.GetClassname() != "player") {
			info.early_out = true
			return
		}
		if (info.attacker.GetTeam() == teamNum) {
			info.early_out = true
		}
		else {
			// Recovery handling
			if (!isRecovering) {
				isRecovering = true
				::createTimer(1, @[this]() handleRecovery())
				stagger += 10
			}
			stagger += info.damage
			if (stagger > maxStagger) stagger = maxStagger
			if (!isSapped) bot.TakeDamage(0, 1, info.attacker)
			hitEvent.triggerEffects(info)
			setHp(hp - info.damage)
			// Keep the hitbox's health to its id
			::fire(hitbox, "SetHealth", ""+id)
		}
		return this
	}

	handleRecovery = function() {
		playSparkles()
		stagger -= 10
		if (stagger < 0) stagger = 0
		if (stagger > 0) ::createTimer(1, @[this]() handleRecovery())
		else {
			if (hp < maxHp) {
				setHp(hp+10)
				playParticle(teamNum == 2 ? "healthgained_red" : "healthgained_blu", Vector(RandomFloat(-1,1)*12, RandomFloat(-1,1)*12, RandomFloat(1,1.5)*48))
			}
			if (hp > maxHp) hp = maxHp
			if (hp == maxHp) isRecovering = false
			else ::createTimer(1, @[this]() handleRecovery())
		}
		return this
	}

	playParticle = function(particle, offset = Vector(0,0,0), angles = Vector(0,0,90)) {
		DispatchParticleEffect(particle, bot.GetOrigin()+offset, angles)
		return this
	}

	playSparkles = function() {
		local amtPlayed = 0
		local attemptsToPlay = RandomInt(1,(5*(1-(hp/maxHp))).tointeger()+1)
		for (local i = attemptsToPlay; i > 0; i--) {
			local randomValue = RandomFloat(0,1)
			local cmpValue = hp/maxHp
			if (randomValue > cmpValue) {
				amtPlayed++
				playParticle("arm_detonate_sparks", Vector(RandomFloat(-1,1)*12, RandomFloat(-1,1)*12, RandomFloat(0.5,1.25)*48))
			}
		}
		return this
	}

	emitSound = function(soundName) {
		EmitSoundEx({
			sound_name = soundName,
			origin = bot.GetOrigin(),
			sound_level = 70
		})
		return this
	}

	setHp = function(amt) {
		hp = amt
		if (hp > maxHp) hp = maxHp
		if (hp <= 0) die()
		else {
			local color = ((205*hp/maxHp)+50).tointeger()
			::fire(bot, "color", ""+color+" "+color+" "+color)
		}
		return this
	}

	setTeam = function(num) {
		teamNum = num
		bot.SetSkin(teamNum-2)
		bot.SetTeam(teamNum)
		hitbox.SetTeam(teamNum)
		return this
	}

	die = function() {

		// Die
		deaths++
		isDead = true
		if (isSapped) doRestore()
		deathEvent.triggerEffects()
	
		// Stop recovering
		setHp(maxHp)
		stagger = 0
	
		// Play death animation
		emitSound("weapons/airstrike_small_explosion_03.wav")
		playParticle("rd_robot_explosion", Vector(0,0,0), Vector(90,0,0))
		::spawnDeadRobot(bot.GetOrigin(), bot.GetAbsAngles()+Vector(0,0,0), teamNum)
	
		// Spawn cores
		for (local i = 0; i < coresAmt; i++) {
			::spawnCore({
				teamNum = teamNum
				origin = bot.GetOrigin()+Vector(0,0,0)
				value = 5
			})
		}
	
		// Hide
		locateTo(::limbo)

		return this
	}

	spawn = function(spawnpointOverride = null) {
		isDead = false
		id = RandomInt(10000, 99999)
		::fire(hitbox, "SetHealth", ""+id)
		locateTo(spawnpointOverride || spawnpoint)
		spawnEvent.triggerEffects()
		return this
	}

	setSpawnpoint = function(entity) {
		spawnpoint = entity
		return this
	}

	handleInit = @() null // Instance Hook

	sap = function() {
		isSapped = true
		stop()
		emitSound("weapons/sapper_removed.wav")
		::createTimer(1e-45, @[this]() hitbox.SetModel("models/player/demo.mdl"))
		// No idea why, but if this isn't delayed then the particle (any) won't play when using the sapper
		::createTimer(0, @[this]() playParticle(teamNum == 2 ? "highfive_red_old" : "highfive_blue_old", Vector(0,0,56)))
		::input(sappedSound, "PlaySound")
		sappedParticle = SpawnEntityFromTable("info_particle_system", {
			effect_name = teamNum == 2 ? "sparks_powerline_red" : "sparks_powerline_blue"
			origin = bot.GetOrigin()+Vector(0,0,56)
			start_active = 1
		})
		::input(sappedParticle, "SetParent", "!activator", bot)
		sapEvent.triggerEffects()
	}

	restore = function() {
		doRestore()
		emitSound("weapons/sapper_removed.wav")
		playParticle(teamNum == 2 ? "rps_win_flash_red" : "rps_win_flash_blue", Vector(0,0,32))
		restoreEvent.triggerEffects()
	}

	doRestore = function() {
		hitbox.SetModel("models/buildables/sentry1.mdl")
		::input(sappedParticle, "Stop")
		sappedParticle.Kill()
		sappedParticle = null
		::input(sappedSound, "StopSound")
		isSapped = false
	}

}

::onRobotsCreated <- @() null // Global hook

::robots <- []
::setupRobots <- function() {
	foreach (robotSpawn in ::collect("tf_robot_destruction_robot_spawn", "FindByClassname")) {
		
		local setupData =  ::getScope(robotSpawn).setupData
		local robot = {}.setdelegate(::robotsDelegate)
		::robots.push(robot)

		robot.id <- 9999
		robot.name <- setupData.initialName
		robot.spawnpoint <- ::first(setupData.initialLocation) || robotSpawn
		robot.bot <- ::first(robotSpawn.GetName()+"_robot")
		robot.target <- setupData.target
		robot.destination <- null
		robot.teamNum <- ::teamNum(setupData.initialGroup)
		robot.maxHp <- setupData.initialMaxHealth
		robot.hp <- robot.maxHp
		robot.coresAmt <- NetProps.GetPropInt(robotSpawn, "m_spawnData.m_nNumGibs")
		robot.deaths <- 0
		robot.isDead <- true
		robot.deathEvent <- ::createEvent()
		robot.hitEvent <- ::createEvent()
		robot.spawnEvent <- ::createEvent()
		robot.sapEvent <- ::createEvent()
		robot.restoreEvent <- ::createEvent()
		robot.stagger <- 0
		robot.isRecovering <- false
		robot.maxStagger <- 100
		robot.hitbox <- SpawnEntityFromTable("obj_sentrygun", {})
		robot.isSapped <- false
		robot.sappedParticle <- null
		robot.sappedSound <- SpawnEntityFromTable("ambient_generic", {
			message = "Weapon_Sapper.Timer"
			volstart = 10
			spawnflags = 16
		})

		::getScope(robot.target).handleOnPass <- robot.handleOnPass.bindenv(robot)
		::getScope(robot.hitbox).handleDamage <- robot.handleDamage.bindenv(robot)
		::getScope(robot.hitbox).robotRef <- robot

		::input(robot.hitbox, "SetParent", robot.bot.GetName())
		::input(robot.hitbox, "SetParentAttachment", "wheel")
		::input(robot.hitbox, "Hide")
		NetProps.SetPropInt(robot.hitbox, "m_CollisionGroup", 3) // Thx RIPY! Syringes weren't working when using SetSolidFlags(2) and now they do.
		NetProps.SetPropBool(robot.hitbox, "m_bCarried", true) // Funny sapper bug fix: if you switched from sapper to weapon the close-by hidden sentry would reenable

		::input(robot.sappedSound, "SetParent", robot.bot.GetName())
		::input(robot.sappedSound, "SetParentAttachment", "wheel")

		NetProps.SetPropString(robotSpawn, "m_iName", robot.name+"_spawn")
		NetProps.SetPropString(robot.bot, "m_iName", robot.name+"_robot")
		NetProps.SetPropString(robot.hitbox, "m_iName", robot.name+"_hitbox")

		robot.bot.SetSolidFlags(4) // No collisions nor hitbox

		robot.handleInit()
		robot.doTeleportTo(::limbo).setTeam(robot.teamNum).spawn()
	}
	::onRobotsCreated()
}

::getEvent("player_builtobject").addEffect(
	function(data) {
		local obj = EntIndexToHScript(data.index)
		if (obj.GetClassname() != "obj_attachment_sapper") return
		local sappedSentryScope = ::getScope(obj.GetMoveParent())
		if (!("robotRef" in sappedSentryScope)) return
		::fire(obj, "Kill", "", 1e-45)
		local sappedRobot = sappedSentryScope.robotRef
		if (sappedRobot.isSapped) return
		local currentDeaths = sappedRobot.deaths
		sappedRobot.sap()
		::createTimer(6, function[sappedRobot]() {
			if (currentDeaths == deaths) restore()
		})		
	}
)